#ifndef __data_h_
#define __data_h_

#include <gnome.h>

GList *acc_list, *trans_list, *schedule_list;

typedef struct _AccountData AccountData;
typedef struct _TransactionData TransactionData;
typedef struct _ScheduleData ScheduleData;

#define AccountPtr(x) ((AccountData *)(x))
#define TransactionPtr(x) ((TransactionData *)(x))
#define SchedulePtr(x) ((ScheduleData *)(x))

#define ACCOUNT_NAME_SIZE 32

struct _AccountData {
     AccountData *parent;
     gboolean reversed;
     gboolean unlimited;
     gchar name[ACCOUNT_NAME_SIZE];

     gdouble amount;

     GtkCTreeNode *tree_node; 
     gpointer extra_data;
};

#define TRANSACTION_DESC_SIZE 64

struct _TransactionData {
     AccountData *acc_from, *acc_to;
     gdouble amount;
     GDate date;
     gchar desc[TRANSACTION_DESC_SIZE];

     gboolean inbound;
     gint row; /* -1 = is not in the clist */
};

#define SCHEDULE_DESC_SIZE 68

struct _ScheduleData {
	AccountData *acc_from, *acc_to;
	gdouble amount;
	GDate date;
	gchar desc[SCHEDULE_DESC_SIZE];
	gint frequency;
  gint factor;
	gboolean prompt;
	gint row;
};

void data_init(void);
void data_read(const gchar *filename);
void data_write(const gchar *filename);
void data_done(void);

void data_set_standard_accounts(void);

void data_rebound_transactions(const gchar *expr);
void data_recalculate_accounts(void);

#endif

