#include <config.h>

#include <gnome.h>
#include "gnome-ucombo.h"

#include <langinfo.h>
#include <time.h>

#include "misc.h"

#include "date_entry.h"


void date_entry_selected_from_calendar(GtkWidget *calendar, GnomeUcombo *date_entry)
{
	guint year, month, day;
	GDate date;
	char text[16];

	gtk_calendar_get_date(GTK_CALENDAR(calendar), &year, &month, &day);
	month++;

	g_date_set_dmy(&date, day, month, year);
	misc_date_strftime(text, 16, &date);
	gtk_entry_set_text(GTK_ENTRY(date_entry->entry), text);	
}

GtkWidget *date_entry_new()
{
	GtkWidget *date_entry;

	GtkWidget *calendar;

	calendar = gtk_calendar_new();
	date_entry = gnome_ucombo_new(calendar);

	gtk_signal_connect(GTK_OBJECT(calendar), "day_selected", date_entry_selected_from_calendar, date_entry);
	gtk_signal_connect(GTK_OBJECT(calendar), "day_selected_double_click", date_entry_selected_from_calendar, date_entry);

	gtk_signal_connect_object(GTK_OBJECT(calendar), "day_selected_double_click", 
				  gnome_ucombo_hide_popup, GTK_OBJECT(date_entry));

	return date_entry;
}

void date_entry_set_date(GtkWidget *date_entry, GDate *date)
{
	gtk_calendar_select_month(GTK_CALENDAR(GNOME_UCOMBO(date_entry)->popwidget), g_date_month(date)-1, g_date_year(date));
	gtk_calendar_select_day(GTK_CALENDAR(GNOME_UCOMBO(date_entry)->popwidget), g_date_day(date));
}

int date_entry_get_date(GtkWidget *date_entry, GDate *date)
{
  struct tm time;

  time.tm_mon = 13;
  strptime(gtk_entry_get_text(GTK_ENTRY(GNOME_UCOMBO(date_entry)->entry)), 
	   misc_date_fmt, &time);
  
  if (time.tm_mon == 13)
       return 1;

  g_assert(g_date_valid_dmy(time.tm_mday, time.tm_mon+1, time.tm_year+1900));

  g_date_set_dmy(date, time.tm_mday, time.tm_mon+1, time.tm_year+1900);
  return 0;
}
