#ifndef __interface_h__
#define __interface_h__

#include <gnome.h>
#include "data.h"

struct Interface {
     GtkWidget *application;
     GtkWidget *limit_entry;
     GtkWidget *accounts_tree;
     GtkWidget *transactions_registry;
     GtkWidget *schedule_list;
     
     gchar filename[1024];
     gboolean changed;

     gint trans_highlight_mode;
} interface;

void interface_build(void);
void interface_free(void);

void interface_setup_filename(const gchar *new_filename);
void interface_setup_limit(gchar *expr);
gchar *interface_get_limit(void);

void interface_build_account_node(AccountData *account);
void interface_setup_account_node_amount(AccountData *account);
void interface_setup_account_node(AccountData *account);
void interface_build_all_accounts(void);
void interface_setup_all_accounts_amount(void);

GList *interface_trans_sort_order;
void interface_build_transaction(TransactionData *trans);
void interface_setup_transaction(TransactionData *trans);
void interface_setup_transaction_colors(TransactionData *trans);
void interface_build_all_transactions(void);
void interface_setup_all_transactions(void);
void interface_setup_all_transactions_colors(void);
void interface_sort_transactions(void);

GList *interface_sched_sort_order;
void interface_build_schedule(ScheduleData *schedule);
void interface_setup_schedule(ScheduleData *schedule);
void interface_build_all_schedules(void);
void interface_setup_all_schedules(void);
void interface_sort_schedules(void);

#endif

