#include <config.h>

#include <gnome.h>

#include "actions.h"
#include "report_acc_axis.h"
#include "report_grp_axis.h"

#include "menu.h"


GnomeUIInfo menu_file[] =
{
    GNOMEUIINFO_MENU_NEW_ITEM(N_("_New"), N_("Create a new document"),
			      action_new, NULL),

    GNOMEUIINFO_SEPARATOR,

    GNOMEUIINFO_MENU_OPEN_ITEM(action_open, NULL),

    GNOMEUIINFO_MENU_SAVE_ITEM(action_save, NULL),

    GNOMEUIINFO_MENU_SAVE_AS_ITEM(action_saveas, NULL),

    GNOMEUIINFO_SEPARATOR,

    GNOMEUIINFO_MENU_PREFERENCES_ITEM(action_preferences, NULL),

    GNOMEUIINFO_SEPARATOR,

    GNOMEUIINFO_MENU_EXIT_ITEM(action_quit, NULL),

    GNOMEUIINFO_END
};

GnomeUIInfo menu_account[] =
{

  GNOMEUIINFO_ITEM_STOCK(N_("_New..."), N_("Add new account"), 
			 action_account_new, GNOME_STOCK_MENU_BLANK),

    GNOMEUIINFO_ITEM_STOCK(N_("_Edit..."), N_("Edit account"), 
			   action_account_edit, GNOME_STOCK_MENU_PROP),

    GNOMEUIINFO_ITEM_STOCK(N_("_Delete..."), N_("Delete account"), 
			   action_account_delete, GNOME_STOCK_MENU_TRASH),

    GNOMEUIINFO_END
};

GnomeUIInfo menu_trans_highlight_list[] =
{
  GNOMEUIINFO_RADIOITEM_DATA(N_("None"), "No highlighting", 
			     action_transaction_set_highlight_mode, 
			     GINT_TO_POINTER(0),
			     GNOME_STOCK_MENU_BLANK),

  GNOMEUIINFO_RADIOITEM_DATA(N_("Striped"), 
			     "Don't know how to better call this mode", 
			     action_transaction_set_highlight_mode, 
			     GINT_TO_POINTER(1),
			     GNOME_STOCK_MENU_BLANK),

  GNOMEUIINFO_RADIOITEM_DATA(N_("Sort order"), 
			     "Highlight equality classes of sort order (?)", 
			     action_transaction_set_highlight_mode, 
			     GINT_TO_POINTER(2),
			     GNOME_STOCK_MENU_BLANK),
  
  GNOMEUIINFO_END
};

GnomeUIInfo menu_trans_highlight[] =
{
     GNOMEUIINFO_RADIOLIST(menu_trans_highlight_list),
     GNOMEUIINFO_END
};

GnomeUIInfo menu_transaction[] =
{

  GNOMEUIINFO_ITEM_STOCK(N_("_New..."), N_("Add new transaction"), 
			 action_transaction_new, GNOME_STOCK_MENU_BLANK),

  GNOMEUIINFO_ITEM_STOCK(N_("_Edit..."), N_("Edit selected transaction"), 
			 action_transaction_edit, GNOME_STOCK_MENU_PROP),

  GNOMEUIINFO_ITEM_STOCK(N_("_Delete"), N_("Delete transaction"), 
			 action_transaction_delete, GNOME_STOCK_MENU_TRASH),

  GNOMEUIINFO_SEPARATOR,
  
  GNOMEUIINFO_ITEM_STOCK(N_("_Select..."), 
			 N_("Select transactions according to the entered expresion"), 
			 action_transaction_select, 
			 GNOME_STOCK_MENU_BLANK),

  GNOMEUIINFO_ITEM_STOCK(N_("_Unselect..."), 
			 N_("Unselect transactions according to the entered expresion"),
			 action_transaction_unselect, 
			 GNOME_STOCK_MENU_BLANK),

  GNOMEUIINFO_ITEM_STOCK(N_("_Reverse selection"), 
			 N_("Reverse selection of transactions"), 
			 action_transaction_reverse_selection, 
			 GNOME_STOCK_MENU_BLANK),

  GNOMEUIINFO_SEPARATOR,

  GNOMEUIINFO_ITEM_STOCK(N_("Transactions _info..."), 
			 N_("Get info on selected transactions"),
			   action_transaction_info, GNOME_STOCK_MENU_BLANK),

  GNOMEUIINFO_SEPARATOR,
    
  GNOMEUIINFO_SUBTREE_HINT(N_("_Highlight mode"), 
			   N_("Ooops - no tooltip for this item?"), 
			   menu_trans_highlight),

  GNOMEUIINFO_END
};

GnomeUIInfo menu_schedule[] =
{

  GNOMEUIINFO_ITEM_STOCK(N_("_New..."), N_("Add new transaction to schedule"), 
			   action_schedule_new, GNOME_STOCK_MENU_BLANK),

  GNOMEUIINFO_ITEM_STOCK(N_("_Edit..."), 
			 N_("Edit selected scheduled transaction"), 
			 action_schedule_edit, GNOME_STOCK_MENU_PROP),
  
  GNOMEUIINFO_ITEM_STOCK(N_("_Delete"), N_("Delete scheduled transaction"), 
			 action_schedule_delete, GNOME_STOCK_MENU_TRASH),

  GNOMEUIINFO_END
};

GnomeUIInfo menu_report_export[] =
{
  { GNOME_APP_UI_ITEM, N_("Cat"), NULL,
    (gpointer)action_report_filter, (gpointer)"cat - >~/emma-filter.out", NULL,
    GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType) 0, NULL },

  GNOMEUIINFO_END
};

/* Be carefull to change index of 'Export' submenu
   in menu_add_report_filter, when adding new items */
GnomeUIInfo menu_report[] =
{

  GNOMEUIINFO_ITEM_STOCK(N_("Edit _acc-axis..."), N_("Edit accounts axis"), 
			 report_acc_axis_edit, GNOME_STOCK_MENU_BLANK),

  GNOMEUIINFO_ITEM_STOCK(N_("Edit _grp-axis..."), N_("Edit groups axis"), 
			 report_grp_axis_edit, GNOME_STOCK_MENU_BLANK),

  GNOMEUIINFO_ITEM_STOCK(N_("Invoke druid..."), N_("???"), 
			 action_report_druid, GNOME_STOCK_MENU_BLANK),

  GNOMEUIINFO_ITEM_STOCK(N_("_Rebuild"), N_("Rebuilds the report"), 
			 action_report_rebuild, GNOME_STOCK_MENU_REFRESH),

  GNOMEUIINFO_SEPARATOR,

  GNOMEUIINFO_SUBTREE_HINT(N_("_Export"), 
	N_("Exports the report through a pipe into a separate process"), 
			   menu_report_export),

  GNOMEUIINFO_END
};

GnomeUIInfo menu_limit[] = 
{
  GNOMEUIINFO_ITEM_STOCK(N_("_Edit limit..."), N_("Edit limit manually"), 
			 action_limit_edit, GNOME_STOCK_MENU_PROP),

  GNOMEUIINFO_ITEM_STOCK(N_("_Clear limit"), N_("Include all transactions"), 
			 action_limit_clear, GNOME_STOCK_MENU_BLANK),

  GNOMEUIINFO_SEPARATOR,

  { GNOME_APP_UI_ITEM, N_("_Apply"), N_("Calcilate limit once again"), 
    (gpointer)action_limit_apply, (gpointer)(GINT_TO_POINTER(TRUE)), NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_REFRESH, 
    0, (GdkModifierType) 0, NULL },

  GNOMEUIINFO_END
};

GnomeUIInfo menu_help[] =
{

  GNOMEUIINFO_HELP("Emma"),

  GNOMEUIINFO_MENU_ABOUT_ITEM(action_about, NULL),

  GNOMEUIINFO_END
};


GnomeUIInfo menu_main[] =
{
  GNOMEUIINFO_MENU_FILE_TREE(menu_file),

  GNOMEUIINFO_SUBTREE_HINT(N_("_Account"), N_("Accounts menu"), 
			   menu_account),

  GNOMEUIINFO_SUBTREE_HINT(N_("_Transaction"), N_("Transactions menu"), 
			   menu_transaction),

  GNOMEUIINFO_SUBTREE_HINT(N_("_Schedule"), N_("Schedule menu"), 
			   menu_schedule),

  GNOMEUIINFO_SUBTREE_HINT(N_("_Report"), N_("Report menu"), menu_report),

  GNOMEUIINFO_SUBTREE_HINT(N_("_Limit"), N_("Limit menu"), menu_limit),

  GNOMEUIINFO_MENU_HELP_TREE(menu_help),

  GNOMEUIINFO_END
};

static GList *menu_report_filters_list;

void menu_init(void)
{
     menu_report_filters_list = NULL;
}

void menu_done(void)
{
  GList *cursor;

  for (cursor = menu_report_filters_list; 
       cursor != NULL; 
       cursor = g_list_next(cursor)) 
    g_free(cursor->data);

  g_list_free(menu_report_filters_list);
}

void menu_add_report_filter(gchar *command, gchar *name, gchar *group)
{
  GtkWidget *top_menu, *menu_widget, *item_widget;

  /* get the menu_widget to which the menu_item will be appended */
  top_menu = GTK_MENU_ITEM(menu_report[5].widget)->submenu;
  if (group != NULL) {
    gint pos = -1;

    menu_widget = gnome_app_find_menu_pos(top_menu, group, &pos);
    if (pos != (-1)) {
      GList *menu_pointer;
      menu_pointer = g_list_nth(GTK_MENU_SHELL(menu_widget)->children, pos-1);
      menu_widget = GTK_MENU_ITEM(menu_pointer->data)->submenu;
    } else {
      GtkWidget *submenu_item;

      menu_widget = gtk_menu_new();
      
      submenu_item = gtk_menu_item_new_with_label(group);
      gtk_menu_item_set_submenu(GTK_MENU_ITEM(submenu_item), menu_widget);
      gtk_widget_show(submenu_item);

      gtk_menu_append(GTK_MENU(top_menu), submenu_item);
    }
  } else 
    menu_widget = top_menu;

  /* create menu_item to be appended */
  item_widget = gtk_menu_item_new_with_label(name);
  menu_report_filters_list = 
    g_list_prepend(menu_report_filters_list, command = g_strdup(command));
  gtk_signal_connect(GTK_OBJECT(item_widget), "activate",
		     GTK_SIGNAL_FUNC(action_report_filter),
		     (gpointer) command);
  gtk_widget_show(item_widget);
  
  /* append */
  gtk_menu_append(GTK_MENU(menu_widget), item_widget);
}

void menu_build(GnomeApp * application)
{
  gnome_app_create_menus(GNOME_APP(application), menu_main);
}

GnomeUIInfo *menu_get_highlight_list(void)
{
  return menu_trans_highlight_list;
}

