
#ifndef __misc_h__
#define __misc_h__

#include <glib.h>
#include <gnome.h>

/* sets the date passed to the current date */
void g_date_set_current(GDate *date);

/* checks if the text contains only white-space */
gboolean only_white_space(const gchar *text);

/* this function translates label and tip entries
   of UIInfo structures - it is a workaround,
   there should be a better way to do it */
void translate_uiinfo(GnomeUIInfo *uiinfo);

/* builds one-column ctree of accounts, 
   with optional ( != NULL) root node */
GtkWidget *misc_build_ctree(GList *acc_list, gchar *root_text);

/* it is a global variable used by the function below
   (it is made global, so it can be easily read/set by preferences
   saving/loading routines as well as by preferences dialog */
#define MISC_DATE_FMT_SIZE 20
extern gchar misc_date_fmt[MISC_DATE_FMT_SIZE];

/* very similar to g_date_strftime except it doesn't take format argument
   but figures it out itself */
void misc_date_strftime(gchar *string, gsize n, GDate *date);

#endif

