#ifndef __py_module_h_
#define __py_module_h_

#include "data.h"

#define PY_EXPRESSION_MAX_SIZE 256

typedef struct _PyModuleFuncDesc PyModuleFuncDesc;
#define PyModuleFuncDescPtr(x) ((PyModuleFuncDesc *)(x))
struct _PyModuleFuncDesc {
     gchar *name, *desc;
};

GList *py_module_func_desc;

void py_module_init(void);
void py_module_import_module(const gchar *module_name);
void py_module_include_file(gchar *filename, const gboolean verbose_cant_find);
void py_module_done(void);

gdouble py_module_eval_amount(gchar *expr);

void py_module_compile_limit(const gchar *expr);
gboolean py_module_eval_limit(TransactionData *trans);
void py_module_release_compiled_limit(void);

gboolean py_module_error_occurred(void);
void py_module_clear_error(void);
const gchar *py_module_get_error_string(void);

#endif









