#ifndef __report_acc_axis_h__
#define __report_acc_axis_h__

#include <glib.h>

#include "data.h"

typedef struct _ReportAccountData ReportAccountData;
#define ReportAccountDataPtr(x) ((ReportAccountData *)(x))

struct _ReportAccountData {
  AccountData *account;
  guint32 rgb;
  gboolean reversed;
};

/* a list of *ReportAccountData */
GList *report_acc_axis_list;

/* initializes the above list to be empty */
void report_acc_axis_init(void);

/* frees memory taken by the list */
void report_acc_axis_done(void);

/* makes sure that every account from the report_acc_axis exist */
void report_acc_axis_check(void);

/* let the user edit accounts axis, using appropriate dialog 
 * returns true if the user really edit something
 */
gboolean report_acc_axis_edit(void);

#endif
