#include <config.h>

#include "actions.h"
#include "misc.h"

#include "toolbar.h"


GnomeUIInfo toolbar_data[] =
{
  {GNOME_APP_UI_ITEM, N_("New"), N_("Create a new document"), 
   action_new, NULL, NULL, 
   GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_NEW},

  {GNOME_APP_UI_ITEM, N_("Open"), N_("Open a file"), 
   action_open, NULL, NULL, 
   GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_OPEN},

  {GNOME_APP_UI_ITEM, N_("Save"), N_("Save the current file"), 
   action_save, NULL, NULL, 
   GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SAVE},

  GNOMEUIINFO_SEPARATOR,

  {GNOME_APP_UI_ITEM, N_("New transaction"), N_("Add new transaction"), 
   action_transaction_new, NULL, NULL, 
   GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_ADD, 'N', GDK_CONTROL_MASK},
     
  {GNOME_APP_UI_ITEM, N_("Apply limit"), N_("Apply limit to transactions"), 
   action_limit_apply, GINT_TO_POINTER(TRUE), NULL, 
   GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REFRESH},
     
  GNOMEUIINFO_SEPARATOR,

  {GNOME_APP_UI_ITEM, N_("Exit"), N_("Exit the program"), 
   action_quit, NULL, NULL, 
   GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_QUIT},

  GNOMEUIINFO_END
};

void toolbar_build(GnomeApp * application)
{
  translate_uiinfo(toolbar_data);
  gnome_app_create_toolbar(application, toolbar_data);
}

